SystemOrganization addCategory: #'MS-info10-ProfStef'!

AbstractTutorial subclass: #ObjekteKlassenTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MS-info10-ProfStef'!

!ObjekteKlassenTutorial commentStamp: '<historical>' prior: 0!
Eine Einfhrung in den Umgang mit den wichtigsten Programmierwerkzeugen.

ProfStef goOn: ObjekteKlassenTutorial.!

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/31/2010 14:34'!
zeigeKategorienInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse |
	klasse := EllipseMorph.
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	"browserfenster := browser topView."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 1) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/31/2010 14:33'!
zeigeKategorienInBrowser: klasse 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph"
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	"browserfenster := browser topView."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 1) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:05'!
zeigeKlassenInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse |
	klasse := EllipseMorph.
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 3) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:05'!
zeigeKlassenInBrowser: klasse 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph."
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 3) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeMethodenInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse methode|
	klasse := EllipseMorph.
	methode := 'defaultColor'.
	browser := OBSystemBrowser onClass:  klasse selector: methode.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 7) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeMethodenInBrowser: klasse mitMethode: methode 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph.
	methode := 'defaultColor'."
	browser := OBSystemBrowser onClass:  klasse selector: methode.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 7) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 19:27'!
zeigePongSkizze
	"zeigt ein Spielfeld fr Pong mit Ball und Schlger"
	| feld schlaeger ball textp textf button |
	feld := PasteUpMorph new.
	feld extent: 300@200; openInWindowLabeled: 'Mein Pong'; color: Color black.
	"feld extent: 300@200; openInWorld; color: Color black."
	ball := EllipseMorph new extent: 30@30; borderColor: Color white; color: Color green; openInWorld: feld; position: feld position + (120@30).
	schlaeger := RectangleMorph new extent: 100@15; borderColor: Color orange; color: Color red; openInWorld: feld; position: feld position +(150@180).
	textp := TextMorph new contents: 'Punkte:', Character tab asString, ' 13'; color: Color white; openInWorld: feld; position: feld position + (10@5).	
	textf := TextMorph new contents: 'Fehler:', Character tab asString, ' 2/5'; color: Color white; openInWorld: feld; position: feld position + (10@20).
	button := SimpleButtonMorph new label: 'Start/Stop'; useRoundedCorners;  openInWorld: feld; position: feld position + (220@5).! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeProtokolleInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse protokoll |
	klasse := EllipseMorph.
	protokoll :=  'geometry'.
	browser := OBSystemBrowser onClass:  klasse category: protokoll.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 5) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeProtokolleInBrowser: klasse mitProtokoll: protokoll 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph.
	protokoll :=  'geometry'."
	browser := OBSystemBrowser onClass:  klasse category: protokoll.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 5) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 12:22'!
browserInstanzen
	^Lesson
	title: 'Instanzen und Bezeichner'
	lesson:
'"ProfStef previous.
ProfStef next.
ProfStef last. (zurck zur zuletzt gesehenen Lektion)
"

"Um das Beispiel dieser Lektion auszuprobieren, ffne einen ''Workspace'' (Weltmen) und schreibe oder kopiere die Befehlszeilen hinein  (Alt/Cmd/Strg-c und -v). Dann ''do-it''!!"

"Leider haben die beiden Ellipsen aus der vorigen Lektion keine *Namen* oder *Bezeichner*. Daher ist es auch schwierig, ihnen nachtrglich noch weitere Nachrichten zu senden, um sie zu verndern oder zu lschen. Ein Name lsst sich einem neu erzeugten Objekt aber ganz einfach durch eine ''Wertzuweisung'' zuweisen, indem du z.B. statt der ersten Beispielzeile folgendes schreibst:"

| meineEllipse |							"Deklaration einer temporren (Hilfs-)Variablen"
meineEllipse := EllipseMorph new.  		"Erzeugen eines EllipseMorph und Zuweisung eines Namens"
meineEllipse borderWidth:10; borderColor: Color green. 	"Verndern zweier Attributwerte"
meineEllipse openInWorld. 				"Jetzt erscheint die Ellipse links oben am Bildschirm"

"Beachte, dass die Namen von (lokalen) Variablen, also z.B. die Bezeichner von Instanzen wie hier ''meineEllipse'' immer mit einem KLEINBuchstaben beginnen mssen!!"
 
"Du kannst meineEllipse vom Workspace aus auch noch mit folgenden Nachrichten verndern (Beachte die Dezimal*punkte*):"

meineEllipse extent: 50@100.
meineEllipse color: (Color r: 0.7 g: 0.1 b: 0.8).
meineEllipse position: 200@150.

"oder lschen:"

meineEllipse delete.

"Klicke im Browser jetzt wieder auf ''instance''. und gehe zur nchsten Lektion."

ProfStef previous.
ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:28'!
browserKategorien
	^Lesson
	title: 'Browser - Kategorien'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne einen Browser mit hervorgehobener Kategorienliste:"

ObjekteKlassenTutorial zeigeKategorienInBrowser: EllipseMorph.

"Die erste Spalte zeigt die ''Kategorien''. Kategorien sind so etwas wie Programmpakete oder Projekte, in denen verschiedene Klassen zusammengefasst sind. So wird es z.B. einfacher, die von dir selbst programmierten Klassen zu finden und auch als solche zu erkennen. Vor allem aber kannst du dann deinen eigenen Programmtext ganz einfach als ''Monticello-Paket'' aus dem Image exportieren."

"Es ist gute Praxis, die Namen deiner Kategorien mit deinen Initialen beginnen zu lassen. Dein erstes Projekt soll eine Pong-Variante sein. Jetzt ist ein guter Moment, dafr die passende Kategorie anzulegen: "

"Klicke mit der rechten Maustaste in die Kategorienspalte und whle im Kontext-Men ''add category...''"

"Wenn du etwa ''Lieschen Mller'' heit, solltest du als Kategoriename ''LM-Pong'' eingeben (ohne Anfhrungszeichen). Du wirst deine Kategorie immer ziemlich am Ende der Kategorienliste finden."

"Ach ja, speichern: Klicke in den pharo-Hintergrund -> save. Kann nicht schaden..."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:28'!
browserKlassen1
	^Lesson
	title: 'Browser - Klassen - Kommentar'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne einen Browser mit hervorgehobener Klassenliste:"

ObjekteKlassenTutorial zeigeKlassenInBrowser: EllipseMorph.

"Was siehst du?"

"Unterhalb der Klassenliste befinden sich drei Knpfe:
	- instance
	- ?
	- class"

"Klicke das ''?'' an."

"Im unteren Bereich erscheint nun ein Klassenkommentar, in dem zum einen erklrt wird, was ein ''EllipseMorph'' sein soll (generell sind in Smalltalk ''Morphe'' grafische Objekte, die auf dem Bildschirm erscheinen knnen), zum anderen mit zwei Zeilen Beispielcode gezeigt wird, wie man mit dieser Klasse umgeht. Fhre sie doch einfach aus:"

EllipseMorph new borderWidth:10; borderColor: Color green; openInWorld.
EllipseMorph new borderStyle:(SimpleBorder width: 5 color: Color blue); openInWorld.

"Du kannst die beiden Ellipsen einfach mit dem Mauszeiger packen und verschieben. Wenn du sie bei gedrckter Umschalttaste mit der mittleren Maustaste anklickst, erscheint auch das Halo, das du von Etoys her kennst. So kannst du sie auch wieder loswerden."

"Sieh dir die beiden Befehlszeilen genauer an. Was passiert da der Reihe nach?"

"Erst wird mit" EllipseMorph new . "eine neue Ellipse, also eine ''Instanz'' der Klasse EllipseMorph erzeugt. ''new'' ist dabei eine Nachricht an die *Klasse* EllipseMorph."

"Anschlieend erhlt diese *Instanz*, also das neu erzeugte *Objekt* in Befehlskaskaden (erinnerst du dich an die Strichpunkte?) die Nachrichten ''borderWidth:'', ''borderColor:'', ''borderStyle:'' und ''openInWorld'', wobei letztere dafr sorgt, dass die Ellipse am Bildschirm erscheint. Dabei werden auch noch je eine Instanz der Klassen ''Color'' und ''SimpleBorder'' erzeugt."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:42'!
browserKlassen2
	^Lesson
	title: 'Browser - Klassen - instance - Klassenhierarchie'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne ggf. erneut einen Browser mit hervorgehobener Klassenliste"

ObjekteKlassenTutorial zeigeKlassenInBrowser: EllipseMorph.

"und klicke auf ''instance'' unterhalb der Klassenliste."

"Was steht jetzt unten im Definitionsbereich? Wichtig sind frs erste folgende drei Eintrge:"

BorderedMorph subclass: #EllipseMorph

"EllipseMorph ist also eine Unterklasse von BorderedMorph. Beachte das ''#'' vor dem Klassennamen. (Der Klassenname wird so als *Symbol* eindeutig erzeugt.)"

"Einen berblick ber alle Oberklassen von EllipseMorph erhltst du, indem du im Browser auf das bunte rechteckige Symbol vor dem Klassennamen oder auf den ''hierarchy''-Knopf klickst, oder mit"

EllipseMorph browseHierarchy

"Dann ffnet sich ein Hierarchie-Browser. Ihm fehlt die Kategorienliste, dafr sind in der Klassenliste die Ober- und Unterklassen in ihrer Hierarchie aufgelistet."

	instanceVariableNames:  ''''

"Hier stehen zwischen einfachen Anfhrungszeichen die Instanzvariablen, also die Attribute von Instanzen der Klasse."

"Hat ein EllipseMorph wirklich keine Attribute? Im Klassenkommentar war doch die Rede von ''borderWidth'' und ''borderColor''?!!? Wo stehen die dann?"

"Wechsle noch einmal zum Hierarchie-Browser fr EllipseMorph und schau dir die Oberklassen an - gefunden? Wie viele Attribute hat ein EllipseMorph insgesamt? Wie heien sie?"

	category: ''Morphic-Basic''

"Die Klasse EllipseMorph ist der Kategorie ''Morphic-Basic'' zugeordnet, gehrt also zu den einfachen grafischen Objekten, die man immer wieder bentigt. Welche anderen Morphe sind das?"
 
"Solltest du einmal eine Klasse in eine andere Kategorie einordnen wollen, kannst du entweder diesen Eintrag ndern, oder sie einfach mit dem Mauszeiger im Browser in die andere Kategorie ziehen. Das gilt spter auch fr das Umordnen von Methoden und Protokollen."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:28'!
browserKlassen3
	^Lesson
	title: 'Browser - Klassen - class'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne ggf. erneut einen Browser mit hervorgehobener Klassenliste"

ObjekteKlassenTutorial zeigeKlassenInBrowser: EllipseMorph.

"Wenn du unterhalb der Klassenliste auf ''class'' klickst, erhltst du Zugriff auf die Methoden, die man - etwa bei der Instanzerzeugung - direkt an die Klasse schicken kann."

"Das ist fr dich nur bei wenigen Klassen interessant. Bei EllipseMorph siehst du da z.B. gar nichts, dafr aber bei Color oder Character. Dort findest du etwa die Definitionen fr benannte Farben wie" Color blue. "oder Sonderzeichen wie" Character tab.

"Sieh dich etwas um:"

Color browse.
Character browse.

"Jetzt wird es aber Zeit, dass du endlich deine ersten eigenen Klassen anlegst!!"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/3/2011 23:01'!
browserMethoden
	^Lesson
	title: 'Browser - Methoden - Rckgabewert'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Der Bauplan jeder Methode in Smalltalk:"

	messageSelectorAndArgumentNames
		"comment stating purpose of message"

		| temporary variable names |
		statements
.
"	- In der ersten Zeile steht der Name der Methode und ggf. die Namen der Parameter. 
	  Methodennamen beginnen immer mit einem KLEINbuchstaben!!
	- Als zweites kommt in doppelten Anfhrungszeichen ein Kommentar, 
	  der die Funktion der Methode erklrt.
	- Bei Bedarf werden dann zwischen zwei senkrechten Stichen die Namen von 
	  Hilfsvariablen deklariert,
	- Anschlieend folgen die eigentlich auszufhrenden Befehle."

"ffne einen Browser mit hervorgehobener Methodenliste:"

ObjekteKlassenTutorial zeigeMethodenInBrowser: EllipseMorph mitMethode: ''defaultColor''.

"Sieh dir die Methodendefinition an:"

	defaultColor
		"answer the default color/fill style for the receiver"     .
		^ Color yellow
.
"Der Kommentar erklrt, was die Methode leistet: Sie gibt die Standardfllung des Morphs als Ergebniswert zurck. In diesem Fall ist das eine Instanz der Farbe Gelb."

"Entscheidend ist hier der *Rckgabeoperator* ''^'' in der letzten Zeile. (Manchmal wird er auch als Pfeil nach oben dargestellt, auf der Tastatur ist es aber immer das Dach-Symbol.) Er entspricht der ''return''-Anweisung in anderen Programmiersprachen und besagt folgendes:

	Liefere den Wert der aktuellen Zeile als Ergebnis an den Sender der Nachricht 
	und beende die Methode.
	Nachfolgende Befehlszeilen werden nicht mehr ausgefhrt!!"
	
"Da dein PongBall eine Unterklasse von EllipseMorph ist, erbt er diese Methode und ist deshalb auch von Haus aus gelb. Ellipsen sollen von Haus aus gelb bleiben, deine Pongblle aber nicht. ndere das daher folgendermaen, indem du die Methode *berschreibst*:

	- ffne einen Browser fr deine PongBall-Klasse.
	- Whle in der Protokollliste ''-- all --'' aus.
	- Ersetze im Definitionsbereich die Methodenvorlage 
	  durch obigen Text von EllipseMorph>>defaultColor.
	- Speichere ihn schon einmal mit Alt/Cmd/Strg-s.
	- In der Protokollliste erscheint jetzt ein ''as yet unclassified'',
	  weil die Methode noch zu keinem Protokoll gehrt.
	- Rechtsklick auf die Protokollliste:
	- ''categorize automatically''
	- Weil es sich bei ''defaultColor'' um eine Standardmethode handelt,
	  wird sie automatisch in das Protokoll ''defaults'' einsortiert.
	
	- ffne einen Browser fr die Klasse ''Color'':" Color browse. " 
	- Klicke unterhalb der Klassenliste auf ''class''.
	- Whle das Protokoll ''named colors''.
	- Suche dir in der Methodenliste statt ''yellow'' einen anderen Farbnamen aus.
	- Fge ihn statt ''yellow'' in die ''defaultColor''-Methode deines PongBalls ein und speichere."

"Probier''s aus und erzeuge hier oder in einem Workspace eine Instanz *deiner* PongBall-Klasse:"

MSPongBall new openInHand.

"Passt das soweit?"

"Weit du noch, wie du das Halo bekommst oder dem Ball im Workspace erst einen Namen zuweist, um ihn wieder lschen zu knnen? Probier das noch einmal aus und sorge dann dafr, dass auch der Schlger von Haus aus eine passende Farbe bekommt."

"Wenn du in der Protokollliste ''-- all --'' auswhlst, siehst du in der Methodenliste smtliche Methoden, die in der Klasse definiert, man sagt auch, *implementiert* sind. Was ist in der Liste bei der Methode ''defaultColor'' anders als bei den Accessoren?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/3/2011 15:01'!
browserMethodenUeberschreiben
	^Lesson
	title: 'Methoden berschreiben - Implementoren'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne ggf. einen Browser mit hervorgehobener Methodenliste. EllipseMorph kannst du gerne auch durch deine PongBall-Klasse ersetzen:"

ObjekteKlassenTutorial zeigeMethodenInBrowser: EllipseMorph mitMethode: ''defaultColor''.

"Vor ''defaultColor'' erscheint ein grnes Pfeilsymbol. Wenn du das anklickst (tu das!!), wirst du gebeten, aus einer Liste einen ''Implementor'' auszuwhlen. In der Liste stehen die Ober-/Unterklassen der aktuellen Klasse, in denen eine Methode gleichen Namens definiert oder ''implementiert'' ist. Man sagt, diese Methoden werden hier ''berschrieben'' oder ''berladen''."

"Whle die verschiedenen Implementierungen aus. Welche Farbe hat ein Morph normalerweise?"

"TIPP: Rechter Mausklick oder Alt/Cmd/Strg-f in der Kategorienliste bietet ein Suchfeld fr Klassennamen."

"Ab jetzt wechsest du bei deinen Klassen am besten in die Hierarchie-Ansicht im Browser (''hierarchy''-Knopf), dann kannst du bequem durch die Oberklassen wandern."

"Noch ist dein Ball nicht kreisfrmig, auch der Schlger hat vermutlich noch die falsche Form. Auch knntest du bei beiden noch Randfarbe und -strke anpassen. All diese Eigenschaften werden ber Standardmethoden wie ''defaultColor'' gesteuert. Durchsuche daher die Oberklassen deiner beiden Klassen nach entsprechenden ''defaultXYZ''-Methoden und berschreibe sie ananlog zu ''defaultColor''. Am besten whlst du dabei gleich vor dem Schreiben das Protokoll ''defaults''. Ansonsten kannst du die neuen Methoden auch mit dem Mauszeiger in das Protokoll ziehen oder ''categorize automatically''."

"Erzeuge zur Kontrolle auch Instanzen. Du kannst dich auch an der Beispielskizze orientieren:"

ObjekteKlassenTutorial zeigePongSkizze.

"Wenn du das geschafft hast, gehe zur nchsten Lektion:"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 20:20'!
browserProtokolle
	^Lesson
	title: 'Browser - Protokolle'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Wenn du Accessoren erzeugst, erscheint in der dritten Spalte des Browsers ''accessing''. Das nennt man in Smalltalk das *Protokoll*, zu dem die Get- und Set-Methoden gehren."

"ffne einen Browser mit hervorgehobener Protokollliste:"

ObjekteKlassenTutorial zeigeProtokolleInBrowser: EllipseMorph mitProtokoll: ''geometry''.

"Du siehst hier einige bliche Protokolle:
	- accessing
	- geometry
	- initialization
	- testing
Ebenso wie die Kategorieren fr die Klassen sind Protokolle einfach nur logische Gruppierungen von Methoden, um besser die bersicht zu behalten."

"''accessing'' kennst du bereits, was mit ''geometry'' gemeint ist, kannst du dir vermutlich denken. In ''initialization'' sind alle Methoden versammelt, die mit der Erzeugung von Instanzen zu tun haben - sprich alles, was in Folge der Nachricht ''new'' passiert. ''testing'' beinhaltet gewhnlich Nachrichten, auf die ein Objekt mit ''Ja'' oder ''Nein'' antwortet - etwa ''Reagierst du auf Tastatureingaben?''"

"Du kannst bei deinen eigenen Klassen auch Protokolle hinzuzfgen oder verndern. ffne dazu z.B. einen Browser fr deine PongBall-Klasse:"

MSPongBall browse.

"TIPP: Rechtsklick auf die Kategorienliste im Browser bietet ein ''find class...(f)'' (Geht also auch mit Alt/Cmd/Strg-f). Da kannst du dann den Namen (oder Teile davon) der Klasse eingeben, die du suchst."

"Rechtsklick auf die Protokollliste liefert ein Kontextmen, in dem vor allem die ersten beiden Eintrge interessant sind:
	- ''add category''
	- ''categorize automatically''
Ersteres ist klar, denke ich - ''category'' meint hier ''Protokoll''. Letzteres fhrt dazu, dass alle bereits vorhandenen Methoden automatisch in irgendwelche Protokolle einsortiert werden. Bei den Accessoren ist das z.B. passiert."

"Fge jeder deiner drei Klassen das Protokoll ''spielsteuerung''  und deiner PongBall-Klasse zustzlich das Protokoll ''physik'' hinzu. (blicherweise beginnen Protokollnamen mit einem Kleinbuchstaben.)"

"Speichere dein pharo-image wieder einmal!!"

"Whle nun irgendein Protokoll in der Liste aus. Was siehst du dann unten im Definitionsbereich des Browsers?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 17:59'!
browserSenderImplementoren
	^Lesson
	title: 'Sender und Implementoren von Nachrichten'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Damit z.B. die Methode MSPongBall>>defaultMasse ausgefhrt wird, muss der Instanz diese Nachricht erst einmal gesendet werden. Wann/wie/wo passiert das?"

"ffne einen Browser fr deine PongBall-Klasse (Name anpassen!!) und die Methode defaultMasse:"
OBSystemBrowser openOnClass: MSPongBall selector: #defaultMasse.

"In der Knopfleiste gibt es einen Knopf ''senders''. Wenn du mit dem Mauszeiger etwas darber bleibst, erscheint auch ein Hilfetext. ''Sender'' sind alle Methoden, in denen diese Nachricht gesendet, also die aktuelle Methode aufgerufen wird. Klicke darauf!!"

"Was siehst du? berrascht?"

"Wiederhole das gleiche fr die Methode defaultColor:"
OBSystemBrowser openOnClass: MSPongBall selector: #defaultColor.

"Was siehst du jetzt? Interessant sind nur Methoden von Oberklassen deiner Klasse, hier also von Morph. Sieh dir die Methoden an!!"

"Entscheidend ist die Methode ''initialize'', man nennt sie auch den *Konstruktor* der Klasse. "

"ffne Morph>>initialize im Browser:"
OBSystemBrowser openOnClass: Morph selector: #initialize.

"Sieh dir die Methodendefinition genau an. Was passiert da alles?"

"In der Knopfleiste des Browsers gibt es auch einen Knopf ''implementors''. Damit erhltst du eine Liste aller Klassen, in denen die aktuelle Methode ebenfalls definiert, also *implementiert* ist. Sieh dir ein paar davon an, indem du sie in der linken Spalte auswhlst. Unten wird dann die Definition gezeigt. Was ist allen Definitionen von ''intialize'' gemeinsam?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:28'!
browserUeberblick
	^Lesson
	title: 'Browser - berblick'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Der Browser ist das zentrale Werkzeug beim Programmieren. Mit ihm verwaltest du alle Klassen und den zugehrigen Quelltext.

Es gibt verschiedene Mglichkeiten, einen Systembrowser zu ffnen:"

"- Klick in den Hintergrund, dann ''System Browser'' im Weltmen whlen."
"- Markieren eines Klassennamens, Rechtsklick und dann ''Alt/Cmd/Strg-b'' (fr ''browse''). Probier''s aus:"

EllipseMorph 

"- Senden der entsprechenden Nachricht an eine Klasse:"

EllipseMorph browse.

"Der Browser besitzt oben eine Suchzeile, mit der du z.B. nach Klassen oder Methoden suchen kannst, darunter vier Spalten mit Listen, eine Knopfleiste und zuunterst den Definitionsbereich, in dem du Programmtext oder Kommentare lesen und bearbeiten kannst."

"Als nchstes die vier Listenspalten im einzelnen (Fhre die Befehlszeilen jeweils aus ''do-it''):"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/3/2011 23:38'!
defaultMethoden
	^Lesson
	title: 'Standardwerte - default-Methoden'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Dein PongBall und PongSchlaeger haben noch weitere Attribute. Wie du z.B. beim Tausammlerprojekt unter Etoys gelernt hast, brauchen all diese Attribute sinnvolle Startwerte. Es bewhrt sich, dafr jeweils eigene default-Methoden anzulegen, die diese Standardwerte zurckgeben. Konkret brauchst du folgende Methoden:

PongBall>>defaultMasse
PongBall>>defaultGeschwindigkeit
PongBall>>defaultBeschleunigung
PongBall>>defaultDeltaT

PongSchlaeger>>defaultPunkte
PongSchlaeger>>defaultFehler

Sinnvolle Standardwerte knnten folgende sein:

	- Masse: 			1
	- Geschwindigkeit: 	0@0
	- Beschleunigung: 	0@0
	- deltaT: 			0.01

	- Punkte: 			0
	- Fehler: 			0

Lege all diese default-Methoden an (mit sinnvollen Kommentaren!!) und speichere dann wieder einmal dein pharo-Image."

"TIPP: Am wenigsten Arbeit hast du, wenn du im Browser jeweils deine defaultColor-Methode auswhlst, sie im Definitionsbereich anpasst (den Namen ''defaultColor'' in ''defaultMasse'' nderst, im Kommentar ein, zwei Wrter ersetzt und den richtigen Rckgabewert eintrgst) und sie dann mit Alt/Cmd/Strg-s abspeicherst. Dann ist die neue Methode auch automatisch im gleichen Protokoll."

"TIPP: Rot gefrbter Text im Definitionsbereich des Browsers bedeutet, dass du einen Syntaxfehler in deinem Programmtext hast. Gern sind das vergessene Punkte oder Anfhrungszeichen, aber auch Tippfehler in Methodenaufrufen."

"HINWEIS: Ausdrcke wie ''5@3'' sind in Smalltalk Instanzen der Klasse ''Point'', also zweidimensionale Koordinaten, mit denen man auch rechnen kann:"
(5@3) inspect.
"Whle die folgenden Zeilen jeweils aus, dann Rechtsklick und ''print it (p)'' oder Alt/Cmd/Strg-p:"
(5@3) + (2@ -1).
5@3 * 2.
(5@3) * 2.
2* 5@3.
2 * (5@3).

"Wenn du fertig bist, erzeuge je eine Instanz deiner beiden Klassen und ffne einen Inspektor (Klassennamen anpassen!!):"

MSPongBall new inspect.
MSPongSchlaeger new inspect..

"Passen die Attribute und ihre Werte (alles in der linken Spalte zu sehen)?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/3/2011 23:22'!
erzeugeAccessoren
	^Lesson
	title: 'Zugriff auf Instanzvariablen - Accessoren (Get/Set)'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Im Sinne der Datenkapselung sind Attribute privat, also nur ber (ffentliche) Methoden ansprechbar. Du hast solche Methoden schon aufgerufen, um etwa die Farbe oder Gre eines Objektes zu verndern."

"Diese Methoden, die *Accessoren*, kannst du in pharo fr jede deiner Klassen am einfachsten folgendermaen erzeugen: 

	- Whle im Browser in der Klassenliste die Klasse aus, also etwa MSPongBall.
	- Rechtsklick auf der Klassenliste liefert ein Kontextmen
	- Whle dort
		- ''refactor class'', wenn du fr alle Variablen auf einmal,
		- ''refactor instance variable'', wenn du nur fr ein bestimmtes Attribut Get- und Set-Methode erzeugen willst.
	- Whle ''accessors'' und im sich dann ffnenden Fenster ''accept''."
	
"Mach das fr all deine Klassen. "

"Es werden fr jede Variable zwei Methoden erzeugt:

- eine Get-Methode, die genauso heit wie die Variable, also etwa ''MSPongSchlaeger>>punkte'': Damit kannst du den aktuellen Wert der Instanzvariable auslesen.

- eine Set-Methode, die am Ende des Namens noch einen Doppelpunkt hat, also etwa ''MSPongSchlaeger>>punkte:'': Damit kannst du den Wert der Instanzvariable verndern."

"Du kannst beide Methoden auch ausprobieren. Erzeuge dazu eine Instanz etwa deines PongSchlaegers (Klassenname anpassen!!) und ffne einen Inspektor:"
MSPongSchlaeger new inspect.

"Um den aktuellen Wert des Attributs ''punkte'' auszulesen, gibst du im Inspektor in der Eingabezeile rechts unten"
self punkte.
"ein und dann Rechtsklick und ''print it (p)'' oder Alt/Cmd/Strg-p, um den Wert anzeigen zu lassen."

"Um den Wert der punkte zu verndern, gibst du z.B."
self punkte: 2.
"ein und dann Rechtsklick und ''do it (d)'' oder Alt/Cmd/Strg-d, um den Befehl auszufhren."

"Was hat sich durch das Erzeugen der Accessoren alles im Browser verndert?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 19:39'!
erzeugeAttribute
	^Lesson
	title: 'Attribute und Instanzvariablen'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Was mssen die Objekte in deinem Pong wissen? Was muss man sie fragen knnen? Welche Eigenschaften mssen sich verndern knnen? Kurz: Welche Attribute - in Smalltalk *Instanzvariablen* -  sind ntig?"

"Beginnen wir mit dem Ball: Von der Physik her muss er 
	- seine Position, 
	- Geschwindigkeit, 
	- Beschleunigung und 
	- seine Masse kennen. 
Da seine Bewegung mit Hilfe der Methode kleiner Schritte simuliert werden soll, muss er auch 
	- den Zeitschritt ''dt'' 
der Simulation kennen. 

Wenn du im Browser in der Klassenliste deine PongBall-Klasse auswhlst und in der Knopfleiste unterhalb ''variables'' anklickst, erhltst du eine Auflistung aller Instanzvariablen, die ein PongBall bereits besitzt, weil er ja ein EllipseMorph ist. Whle in der Liste z.B. ''bounds'' aus, dann wird rechts angezeigt, welche Methoden dieses Attribut benutzen und in welcher Oberklasse sie definiert sind. Du siehst dort z.B. ''Morph>>position'' (Die Methode ''position'' ist also in der Oberklasse ''Morph'' definiert.). Wenn du das anklickst, kannst du im unteren Feld lesen, dass mit der Position eines Morphes gewhnlich seine linke obere Ecke gemeint ist."

"Fazit ist jedenfalls, dass jeder Morph seine Position kennt (an sich nicht berraschend, oder?). Also musst du in der Klassendefinition nur die anderen Instanzvariablen eintragen (dann wieder Alt/Cmd/Strg-s !!):"

EllipseMorph subclass: #MSPongBall
	instanceVariableNames: ''v a m dt''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"hnlich sieht es fr den Schlger aus. Neben seiner Position muss er wissen, wie viele Punkte bzw. Fehler er gemacht hat:"

RectangleMorph subclass: #MSPongSchlaeger
	instanceVariableNames: ''punkte fehler''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"Und was muss das ganze Spiel wissen/kennen? Es stellt unter anderem die Verbindung zwischen allen beteiligten Objekten her. Daher sollte es das Spielfeld sowie alle Figuren kennen. Auerdem kann es gnstig sein, wenn es wei, ob es gerade luft oder angehalten ist:"

Object subclass: #MSPong
	instanceVariableNames: ''spielfeld figuren laufend''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"So, und wie greift man nun auf diese Instanzvariablen zu? Wie liest man ihre Werte aus oder verndert sie - wenn sich etwa der Schlger einen Punkt verdient hat? Schlielich sind Attribute grundstzlich privat."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 19:15'!
erzeugeUnterklassen
	^Lesson
	title: '(Unter-)Klassen anlegen'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne einen Browser z.B. mit" OBSystemBrowser open. "und whle in der Kategorienliste deine Pong-Kategorie aus, die du in" 
ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKategorien. 
"angelegt hast. Bei mir heit sie ''MS-Pong'' - Warum habe ich damals diesen Namen gewhlt? Klar?"

"Noch ist diese Kategorie leer - keine Klassen vorhanden. Aber unten im Definitionsbereich des Browsers steht bereits diese Vorlage zum Erzeugen einer neuen Klasse:"

Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"Welche Klassen bentigst du fr deine Pong-Variante? Sieh in deinem UML-Diagramm nach!!"

"Vermutlich folgendes: Ball, Schlger, Textfeld, Schaltknopf, Spielfeld - und das ganze Spiel natrlich. Nicht alles musst du neu erfinden, Textfelder, Schaltknpfe und Spielfelder gibt es in pharo bereits:"

TextMorph browse.
SimpleButtonMorph browse.
PasteUpMorph browse.

"Bleiben MSPong, MSPongBall und MSPongSchlaeger. Beachte, dass Klassennamen immer mit einem GRObuchstaben beginnen mssen!! Vorsichtshalber setze ich auch meine Initialen vor die Klassennamen - nicht dass es Klassen mit diesen Namen bereits gibt."

"Zum Anlegen dieser neuen Klassen musst du nur obige Vorlage im Browser anpassen (also den Klassennamen ndern - achte darauf, dass das ''#'' stehen bleibt!!) und die vernderte Vorlage *speichern* (Alt/Cmd/Strg-s oder Rechtsklick und ''accept (s)'' im Kontextmen), also etwa:"

Object subclass: #MSPong
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"MSPong ist etwas vllig neues, lege es daher direkt als Unterklasse von ''Object'' an, wie gezeigt!! "

"MSPongBall soll im Grunde eine Ellipse mit zustzlichen Attributen und Methoden sein, MSPongSchlaeger ein Rechteck. (Ergnze das ggf. in deinem UML-Diagramm!!) Beides gibt es bereits. Daher kannst du diese Klassen als *Unterklassen* von EllipseMorph bzw. RectangleMorph anlegen:"

EllipseMorph subclass: #MSPongBall
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
RectangleMorph subclass: #MSPongSchlaeger
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"Fehlt frs erste noch eines - weniger fr den Rechner als vielmehr fr dich selber und alle, die dein Projekt einmal benutzen oder weiterentwickeln wollen. Was wohl?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 19:30'!
fazitKlassenAnlegen
	^Lesson
	title: 'Fazit: Klassen anlegen'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Glckwunsch!! Du hast jetzt schon ganz schn etwas geschafft!!"

"Hier zum merken noch einmal zusammengefasst das wichtigste zum Anlegen neuer Klassen:

0. Plane sorgfltig, z.B. mit UML.

1. Lege ggf. eine neue Kategorie mit einem aussagekrftigen Namen fr dein Projekt an (''add category'' in der Kategorienliste). Der Name sollte mit deinen Initialen beginnen.

2. In den meisten Fllen wirst du deine Klassen direkt als Unterklassen von ''Object'' anlegen. Oft empfiehlt es sich aber, erst einmal im Browser nach hnlichen, bereits existierenden Klassen zu suchen (Alt/Cmd/Strg-f in der Kategorienliste)

3. Gib deiner Klasse einen aussagekrftigen Namen (Grobuchstabe am Anfang!!), ebenso den Instanzvariablen (Kleinbuchstabe am Anfang!!).

4. Schreibe einen Klassenkommentar mit einer kurzen Beschreibung und Beispielbefehlen, wie man diese Klasse benutzt.

5. Erzeuge, soweit ntig, Accessoren fr die Instanzvariablen (Rechtsklick auf dem Klassennamen, dann ''refactor class'' oder ''refactor instance variable'' und ''accessors'').

6. Erzeuge defaultXYZ-Methoden mit den Standardwerten der Instanzvariablen. berschreibe dabe ggf. auch Methoden der Oberklassen.

7. berschreibe den Konstruktor (''initialize'') der Oberklasse: Immer zuerst ''super initialize'', dann Wertzuweisungen fr die Instanzvariablen, ggf. Konstruktion aus Bestandteilen (''submorphs'') oder Startmethodenaufruf.

8. Lege sinnvolle Protokolle fr die Methoden an: fr Standardmethoden mit ''categorize automatically'', fr spezielle Dinge mit ''add category'' in der Protokollliste.

9. Bereichere all deine Programmtexte um sinnvolle Kommentare!!

10. Erzeuge testhalber Instanzen deiner Klassen und berprfe sie mit Inspektoren.

11. Speichere ab und an dein pharo-Image."

"Tja, und was machst du, wenn dir im Laufe der Arbeit auffllt, dass du deine Planung verbessern solltest und daher dein Projekt umbauen musst?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 19:25'!
initializeMethode
	^Lesson
	title: 'Konstruktor - initialize'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"ffne Morph>>initialize im Browser:"
OBSystemBrowser openOnClass: Morph selector: #initialize.

"''initialize'' ist die Methode, die als erste beim Erzeugen eines Objektes mit ''new'' aufgerufen wird:"

Morph>>initialize
	"initialize the state of the receiver"
	super initialize.
	owner := nil.
	submorphs := EmptyArray.
	bounds := self defaultBounds.
	color := self defaultColor
.
"In dieser Methode wird frisch erzeugte Instanz richtig ''konstruiert'', daher heit sie auch *Konstruktor*."

"Insbesondere werden alle Attribute mit *Werten* versehen, hier sind das etwa ''bounds'', also die Abmessungen und ''color''. Falls das Objekt aus mehreren Bestandteilen (hier ''submorphs'') besteht, werden diese neu erzeugt und ggf. richtig zusammengesetzt.. Das kannst du z.B. beim MovingEyeMorph schn sehen:"

MovingEyeMorph new openInHand. 	"Zum Entfernen musst du zwei EllipseMorphe lschen."
OBSystemBrowser openOnClass: MovingEyeMorph selector: #initialize.

"Hier werden neben der weien Farbe zwei EllipseMorphe erzeugt und mit addMorphCentered: ineinandergesetzt."

"Manchmal wird am Ende noch ein Startbefehl aufgerufen, etwa bei WatchMorph>>initialize:"

WatchMorph new openInWorld. 	
OBSystemBrowser openOnClass: WatchMorph selector: #initialize.

"Das wirst du vielleicht fr deine Pong-Klasse brauchen."

"Mit am wichtigsten und allen Konstruktoren gemeinsam ist aber die erste Befehlszeile:"

	super initialize.

"In Smalltalk ist jede Klasse eine *Unterklasse* - und sei es nur von ''Object''. Wenn z.B. ein PongSchlaeger erzeugt werden soll, muss erst einmal alles passieren, was auch schon fr die Erzeugung eines RectangleMorphes und damit erst recht alles, was fr die Erzeugung eines Morphes oder eben eines Objects ntig ist. Das musst du aber nicht jedesmal alles wieder neu schreiben.

Stattdessen wird mit *super* erst einmal die entsprechende Methode der *Oberklasse* aufgerufen. Anschlieend folgen nur noch die speziellen Anpassungen fr die aktuelle Klasse."

"Damit sieht z.B. der Konstruktor fr MSPongSchlaeger so aus:"

MSPongSchlaeger>>initialize
	"initialize the state of the receiver"
	super initialize.							"Konstruktor der Oberklasse"
	punkte := self defaultPunkte. 			"Wertzuweisungen fr Instanzvariablen"
	fehler := self defaultFehler.				"Beachte die Doppelpunkte!!"
			
"Lege die Konstruktoren fr deine PongSchlaeger- und PongBall-Klassen an (whle beim Protokoll erst einmal ''-- all --''), fhre dann wieder ''categorize automatically'' aus und speichere dein pharo-Image."

"Wenn du das erledigt hast, erzeuge Instanzen deiner beiden Klassen und untersuche sie mit Inspektoren. Weit du noch, welche Befehle du dafr brauchst? Passen jetzt die Werte der Attribute?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 19:36'!
inspektoren
	^Lesson
	title: 'Inspektoren'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Du kannst bereits Instanzen deiner neuen Klasse erzeugen und mit einem Inspektor untersuchen (ersetze in der folgenden Befehlszeile ''MSPong'' durch den Namen *deiner* Pong-Klasse):"

MSPong new inspect.

"Der Inspektor zeigt die Attribute des Objektes. Nicht gerade viel zu sehen, aber ein MSPong ''wei'' eben noch nicht viel, ist bislang einfach ein Objekt..."

"Sieh dir nun deine Blle und Schlger an (immer mit deinen eigenen Klassennamen!!):"

MSPongBall new openInWorld.
MSPongBall new inspect.
MSPongSchlaeger new openInHand.
MSPongSchlaeger new inspect.

"Hier gibt es schon mehr zu sehen - Geerbtes von den Oberklassen. (Umschalttaste + mittlerer Mausklick liefert das Halo.)"

"Du kannst den Objekten mit dem Inspektor auch Nachrichten schicken: Schreibe in die Eingabezeile rechts unten im Inspektor etwa"

self color: Color red. 

"oder" 

self extent: self extent * 2.

"und dann ''do it (d)''."

"Welche Attribute bentigen deine Klassen noch? Ergnze dein UML-Diagramm ggf. und gehe dann zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 21:30'!
intro
	^Lesson
	title: 'Vorwort'
	lesson:
'ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"In diesem Tutorial lernst du am Beispiel einer einfachen Spielprogrammierung typische Vorgehensweisen und den Umgang mit wichtigen Werkzeugen bei der Programmierung in Smalltalk. Ziel wird eine Variante des Klassikers ''Pong'' sein - angereichert um ein klein wenig Physik."

"So noch nicht geschehen, solltest du zunchst das SmalltalkSyntaxTutorial von ProfStef durcharbeiten:"

ProfStef goOn: SmalltalkSyntaxTutorial.

"Einen berblick ber weitere Tutorials erhltst du im ProfStefBrowser:"

ProfStefBrowser go. "oder zu finden im Weltmen (Klick in den Hintergrund) unter Help"

"Auerdem wird vorausgesetzt, dass du Erfahrungen in der Modellierung mit UML hast, wie du sie z.B. beimTausammler-Projekt in Etoys sammeln kannst."

"Jetzt aber los!!"

"Befehlszeilen im Text (in der Regel alles, was nicht grn erscheint) kannst du meist einfach markieren und mit ''do it (Alt/Cmd/Strg-d) ausfhren. So auch die nachfolgende Zeile, um zur erste Lektion zu gelangen. Solltest du einmal nach deinem Namen gefragt werden, gib ihn in der Form MarkusSchlager ein, also Vor- und Nachname zusammengeschrieben, aber jeweils mit einem Grobuchstaben beginnend."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 19:31'!
kommentiereKlassen
	^Lesson
	title: 'Klassenkommentare'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"*Klassenkommentare*"

"Das ist guter Programmierstil und eine groe Hilfe fr jemanden, der dein Projekt verstehen will, oder auch fr dich selber, wenn du es z.B. einmal weiterentwickeln willst, Fehler suchst oder eine (hnliche) Klasse in einem anderen Projekt bentigst. Gewhne dir daher an, deine Programmtexte *immer* zu kommentieren!!"

"Whle nacheinander deine drei neuen Klassen im Browser aus, klicke auf das ''?'' unterhalb der Klassenliste und schreibe unten im Definitionsbereich eine kurze Beschreibung der jeweiligen Klasse (Speichern mit Alt/Cmd/Strg-s). Zumindest bei der Klasse MSPong sollte auch eine Befehlszeile enthalten sein, mit der man spter das Spiel starten kann, also etwas in dieser Art:"

	MSPong - eine Variante des Klassikers Pong fr einen Spieler von Markus Schlager. 
	Start mit

	MSPong new.

"(Beachte den Punkt am Ende der Befehlszeile.)"

"Sptestens jetzt ist es an der Zeit, wieder einmal dein pharo-Image zu speichern (Klick in den Hintergrund -> Save)"

"Gibt es schon Instanzen deiner neuen Klassen? Wie sehen sie aus? Welche Attribute haben sie bereits? Das zu untersuchen gibt es *Inspektoren*."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:35'!
lessonDummy
	^Lesson
	title: '(Unter-)Klassen anlegen'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKategorien.

"TODO"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 21:54'!
monticelloBrowser
	^Lesson
	title: 'Import und Export von Quelltext - Monticello'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Das derzeit bliche Verfahren, Programmpakete aus dem Image heraus abzuspeichern oder in ein Image zu laden, sind *Monticello-Pakete* (Dateiendung ''.mcz''). Diese werden mit dem *Monticello-Browser* verwaltet. Du hast ihn schon einmal gesehen:"

MCWorkingCopyBrowser  open.

"oder Klick in den pharo-Hintergrund und du findest ihn im Weltmen. ffne ihn jetzt!!

Du siehst zwei Spalten:
	- links eine Liste mit Programmpaketen
	- rechts eine Liste mit ''repositories'', also Speicherorten

Wenn du den Inhalt eines Programmpaketes sehen willst, musst du es nur auswhlen und dann in der Knopfleiste ''Browse'' anklicken. Dann ffnet sich ein Browser hnlich dem SystemBrowser.

Wenn du ein Paket in dein Image laden willst, musst du zustzlich in der rechten Liste ein Repository auswhlen und ''Open'' anklicken. Es erscheint dann ein Fenster, in dem du rechts eine Version des Paketes auswhlen kannst. Im unteren Bereich erscheint dann Anmerkungen zum Paket. Mit ''Load'' kannst du die ausgewhlte Version dann in dein Image laden. Willst du sie dauerhaft behalten, musst du das pharo-Image speichern. 

Willst du ein Paket wieder aus deinem Image entfernen, geht das per Rechtsklick auf dem Paket im Monticello-Browser, dann ''unload package''.

Du willst jetzt *dein Projekt* zum ersten Mal aus dem Image exportieren. 

Dazu musst du erst einmal ein neues Paket fr dein Projekt erzeugen: Klicke dazu auf ''+Package''.

VORSICHT: Du wirst nun nach einem Namen fr dein Paket gefragt. Der *muss* genau so lauten wie der Name der *Kategorie*, die du fr deine Klassen gewhlt hast - oder wie der Anfang des Kategoriennamens. Dann wird automatisch alles in das Paket mit aufgenommen, was sich in Kategorien (oder auch Protokollen) befindet, deren Name mit dem Paketnamen beginnt.

Mein Paket heit daher natrlich MS-Pong.

Wenn du also all deine eigenen Kategorien mit deinen Initialen beginnst, kannst du so auch ganz einfach deine *gesamte* eigene Arbeit auf einmal in ein einziges Paket exportieren. 

Whle in der linken Spalte dein Paket aus. (Wenn du schon einmal sehen willst, was alles zu dem Paket gehrt, kannst du es mit ''Browse'' durchsuchen.)

In der rechten Spalte siehst du bei den Repositories zuoberst einen Pfad der Art

	deinHeimatVerzeichnis/Pharo-X.Y-OneClick.app/Contents/Resources/package-cache

Das ist das Standardverzeichnis, in dem pharo Pakete zwischenspeichert. Die anderen evtl. sichtbaren Repositories sind Server-Adressen im Internet, die die Entwickler von pharo nutzen. 

Willst du deine eigenes Projekt an einem anderen Ort als dem Standardverzeichnis speichern oder eines von dort laden, musst du erst einmal ein entsprechendes Repository hinzufgen - meist wohl ein Verzeichnis auf deinem Rechner. Klicke dazu auf den Knopf ''+Repository'' und whle dann ''directory''. Im nchsten Fenster kannst du dann ein bestehendes Verzeichnis auswhlen oder auch ein neues erzeugen. Es erscheint knftig am Ende der Repository-Liste.

Jetzt musst du links dein Paket und rechts das Repository markieren, in dem du dein Paket abspeichern willst. Klicke dann auf den Knopf ''Save''.

Im nchsten Fenster siehst du oben den Namen der Paketdatei (Paketname-DeinName.Versionsnummer). Im unteren Fenster musst du eine ''Log Message'' eingeben, also eine kurze Beschreibung des Paketes und der nderungen gegenber der zuletzt gespeicherten Version. Dann ''accept''. Fertig."


"Als nchstes steht der Konstruktor fr deine Pong-Klasse an. Wenn er aufgerufen wird, soll unter anderem das fertige Pong-Fenster auf dem Bildschirm erscheinen:" 
ObjekteKlassenTutorial zeigePongSkizze.

"Was muss dazu alles erzeugt und aufgerufen werden? Schreibe dir einen Plan (z.B. als Sequenzdiagramm) zusammen und gehe dann weiter."

ProfStef next.'! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:29'!
oeffneWerkzeuge
	^Lesson
	title: 'Werkzeuge ffnen'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Die typischen Werkzeuge bzw. Fenster, die du beim Programmieren bentigst"

"Fhre die jeweiligen Programmzeilen mit 
 	- Alt-d/Strg-d/Cmd-d oder  
	- Rechtsklick und dann ''Ausfhren / do it (d)'' 
aus oder klicke auf den Hintergrund und ffne die Werkzeuge dann im Men."

"Falls dieses Tutorial verdeckt wird, findest du es immer in der Fensterliste unten am Rand."

"ein Shout-Workspace - ein Fenster mit Syntaxfrbung und -vervollstndigung, in dem du beliebigen Programmtext eingeben und ausfhren kannst"
SHWorkspace open.

"ein SystemBrowser zur Verwaltung der Klassen"
OBSystemBrowser open.

"ein Methodensucher zum Finden von Methoden nach ihrem Namen oder ihrer Funktion (im Weltmen unter ''Tools'' zu finden)"
SelectorBrowser new open.

"ein Transcript - ein Fenster fr Textausgaben, z.B. auch beim Testen deines Programmtextes"
Transcript open.

"ein Monticello-Browser zum Laden und Speichern von Programmpaketen"

MCWorkingCopyBrowser  open.

"So, jetzt schliee erst einmal wieder all die Fenster."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/2/2011 11:29'!
planePong
	^Lesson
	title: 'Das erste Projekt - Pong'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Am Beispiel einer Variante des Computerspielklassikers Pong wirst du im folgenden typische Vorgehensweisen beim Entwickeln in Smalltalk kennenlernen."

ObjekteKlassenTutorial zeigePongSkizze.

"Der Schlger (rotes Rechteck) soll per Tastendruck nach links und rechts bewegt werden. Der Ball soll sich wie unter dem Einfluss der Schwerkraft bewegen. Falls er den Schlger oder den Spielfeldrand trifft, ndert er zufllig seine Bewegungsrichtung etwas. Fr jeden Treffer mit dem Schlger erhlt man einen Punkt. Das Spiel ist zu Ende, wenn der Ball eine vorgegebene Anzahl oft den unteren Spielfeldrand berhrt hat."

"Entwirf nun als erstes ein UML-Klassendiagramm fr so ein Spiel, dann geh zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 21:11'!
refactoring
	^Lesson
	title: 'Refactoring'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"Es ist durchaus nicht ungewhnlich, dass sich im Laufe der Projektentwicklung Verbesserungsbedarf an der einen oder anderen Stelle ergibt. Mal hat einfach nur eine Instanzvariable, Methode oder Klasse den falschen Namen, mal hat aber auch eine Klasse zu viele Funktionalitten, die besser auf mehrere spezialisierte Klassen verteilt werden sollen."

"Derartige Verbesserungen nennt man ''Refactoring''."

"Ein groes Problem besteht dann z.B. darin, dass die vorhandenen Namen bereits an verschiedenen Stellen benutzt werden und folglich berall ausgebessert werden mssten. Damit das nicht uferlos wird, bieten hier Entwicklungsumgebungen wie pharo gute Hilfe."

"An dieser Stelle erst einmal nur der kurze Hinweis: Rechtsklick auf einer der Listen im Browser bietet im Kontextmen eine Reihe vpn Eintrgen zum Refactoring. Wenn du mit dem Mauszeiger eine Weile ber einem Meneintrag verweilst, erscheint in der Regel auch ein Hilfetext dazu."

"Wer wei, vielleicht werden wir das auch bei diesem Projekt noch brauchen. Erst einmal klren wir aber die Frage, wie du dein Projekt so abspeichern kannst, dass es auch andere bentzen knnen."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'tutorial' stamp: 'MarkusSchlager 1/4/2011 21:12'!
tutorial
	^#( 
	#intro 
	#oeffneWerkzeuge 
	#planePong 
	#browserUeberblick 
	#browserKategorien 
	#browserKlassen1 
	#browserInstanzen 
	#browserKlassen2 
	#browserKlassen3 
	#erzeugeUnterklassen 
	#kommentiereKlassen
	#inspektoren
	#erzeugeAttribute 
	#erzeugeAccessoren 
	#browserProtokolle 
	#browserMethoden 
	#browserMethodenUeberschreiben 
	#defaultMethoden
	#wertNil
	#browserSenderImplementoren
	#initializeMethode
	#fazitKlassenAnlegen
	#refactoring
	#monticelloBrowser
	)! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 1/4/2011 10:59'!
wertNil
	^Lesson
	title: 'Fehlende Werte - nil'
	lesson:
'ProfStef previous.
ProfStef next.
ProfStef last. "zurck zur zuletzt gesehenen Lektion"

"So ganz befriedigend ist das ja noch nicht:"

MSPongBall new inspect.
MSPongSchlaeger new inspect..

"Wie du siehst, haben Instanzen der beiden Klassen zwar alle gewnschten Attribute, aber der zugwiesene Wert ist ''nil''."

"''nil'' bedeutet ''nichts'' (in anderen Programmiersprachen heit es ''none'' oder ''null'') und meint eben, dass etwas keinen Wert hat. Oft muss man wissen, ob etwas schon einen Wert hat oder nicht (erinnere dich etwa an das Problem, ob der Kfer im Tausammler-Projekt schon einen Passagier hatte). Deshalb gibt es auch eine Testnachricht ''isNil''. Fhre z.B. bei folgender Zeile ''print it'' oder Alt/Cmd/Strg-p aus:"

PongBall new m isNil.

"Wie man ''isNil'' oft benutzt, kannst du z.B. bei Morph>>formerPosition: sehen, der Methode, mit der ein Morph seine vorige Position verwaltet, wenn er bewegt wird:"

OBSystemBrowser openOnClass: Morph selector: #formerPosition: .

"Bei der Gelegenheit siehst du auch eine zweiseitige Verzweigung in Smalltalk (''wenn - dann - sonst''):"

eineBedingung
	ifTrue:  [dannBefehle ] 
	ifFalse: [sonstBefehle]
.
"Merke dir die eckigen Klammern fr die Anweisungsblcke!!"

"So, aber wie kommen nun die Attribute zu ihren Standardwerten?"

ProfStef next.'.
! !
